#по сути здесь будет запускаться алгоритм BFS для каждой клетки поля
#из нее мы будем стартовать, а добраться хотим до клеток 1-1 и 30-30
#если длина кратчайшего пути из текущей клетки в обе конечные совпадет, то
#в этой клетке кони могут встретиться
#далее мы просто выберем минимальную длину пути
#алгоритм также запоминает клетки, по которым прошел конь, чтобы убедиться в его правильности
def bfs(graph, start, end):
    stack = [[start]]
    visited = set()
    while stack:
        way = stack.pop(0)
        last_cell = way[-1]
        if last_cell == end:
            return way
        elif last_cell not in visited:
            for move in graph[last_cell]:
                new_way = list(way)
                new_way += [move]
                stack.append(new_way)
            visited.add(last_cell)
    return list(visited)
begin = '1-1'
end = '30-30'
graph = {}
horse = [[1, 2], [2, 1], [-1, 2], [2, -1], [-2, 1], [1, -2], [-1, -2], [-2, -1]]
for x in range(1, 31):
    for y in range(1, 31):
        cell = [x, y]
        moves = []
        for i in range(len(horse)):
            new_cell = [cell[0] + horse[i][0], cell[1] + horse[i][1]]
            if 1 <= new_cell[0] <= 30 and 1 <= new_cell[1] <= 30:
                moves.append(str(new_cell[0]) + '-' + str(new_cell[1]))
        graph[str(cell[0]) + '-' + str(cell[1])] = moves

rez1 = []
rez2 = []
for x in range(1, 31):
    for y in range(1, 31):
        way1 = bfs(graph, str(x) + '-' + str(y), begin)
        way2 = bfs(graph, str(x) + '-' + str(y), end)
        if len(way1) == len(way2):
            rez1.append(way1)
            rez2.append(way2)
print(min(rez1, key=len))
print(len(min(rez1, key=len)) - 1)
print(min(rez2, key=len))
print(len(min(rez2, key=len)) - 1)
            
        

            
        
        
    
    
    
        
